-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Charts - Bar Sparklines
This demo illustrates the sparklines of the bar type. A number of properties for each sparkline is changed. Most of these properties define the appearance of specific sparkline elements. Note that in this demo, the Sparkline component obtains data using the DataSource object. You can change filtering conditions for the data using the drop-down menu under the table.
Backend API
$(() => {
const source = new DevExpress.data.DataSource({
load() {
return $.getJSON('../../../../data/resourceData.json');
},
loadMode: 'raw',
filter: ['month', '<=', '12'],
paginate: false,
});
const copOptions = {
dataSource: source,
argumentField: 'month',
valueField: 'copper2021',
type: 'bar',
showMinMax: true,
tooltip: {
format: {
type: 'currency',
precision: 2,
},
},
};
const nickOptions = {
dataSource: source,
argumentField: 'month',
valueField: 'nickel2021',
type: 'bar',
showMinMax: true,
showFirstLast: false,
barPositiveColor: '#6babac',
minColor: '#9ab57e',
maxColor: '#8076bb',
tooltip: {
format: {
type: 'currency',
precision: 2,
},
},
};
const palOptions = {
dataSource: source,
argumentField: 'month',
valueField: 'palladium2021',
type: 'bar',
barPositiveColor: '#e55253',
firstLastColor: '#ebdd8f',
tooltip: {
format: {
type: 'currency',
precision: 2,
},
},
};
$('#choose-months').dxSelectBox({
dataSource: [12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1],
value: 12,
inputAttr: { 'aria-label': 'Month' },
onValueChanged(data) {
const count = data.value;
source.filter(['month', '<=', count]);
source.load();
},
});
$('.cop2021').dxSparkline(copOptions);
$('.nick2021').dxSparkline(nickOptions);
$('.pal2021').dxSparkline(palOptions);
$('.cop2022').dxSparkline($.extend(copOptions, { valueField: 'copper2022' }));
$('.nick2022').dxSparkline($.extend(nickOptions, { valueField: 'nickel2022' }));
$('.pal2022').dxSparkline($.extend(palOptions, { valueField: 'palladium2022' }));
$('.cop2023').dxSparkline($.extend(copOptions, { valueField: 'copper2023' }));
$('.nick2023').dxSparkline($.extend(nickOptions, { valueField: 'nickel2023' }));
$('.pal2023').dxSparkline($.extend(palOptions, { valueField: 'palladium2023' }));
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="long-title"><h3>Monthly Prices of Copper, Nickel and Palladium</h3></div>
<div id="chart-demo">
<table class="demo-table" border="1">
<tr>
<th><div class="dx-screen-reader-only">Year</div></th>
<th>Copper (USD/ton)</th>
<th>Nickel (USD/ton)</th>
<th>Palladium (USD/troy ounce)</th>
</tr>
<tr>
<th>2021</th>
<td><div class="sparkline cop2021"></div></td>
<td><div class="sparkline nick2021"></div></td>
<td><div class="sparkline pal2021"></div></td>
</tr>
<tr>
<th>2022</th>
<td><div class="sparkline cop2022"></div></td>
<td><div class="sparkline nick2022"></div></td>
<td><div class="sparkline pal2022"></div></td>
</tr>
<tr>
<th>2023</th>
<td><div class="sparkline cop2023"></div></td>
<td><div class="sparkline nick2023"></div></td>
<td><div class="sparkline pal2023"></div></td>
</tr>
</table>
<div class="action">
<div class="label">Choose a number of months:</div>
<div id="choose-months"></div>
</div>
</div>
</div>
</body>
</html>
#chart-demo {
height: 440px;
}
.demo-table {
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
.demo-table th,
.demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #c2c2c2;
}
.demo-table th {
padding: 25px 15px 20px;
border: 1px solid #c2c2c2;
}
.demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
.demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
.demo-table .sparkline {
width: 200px;
height: 30px;
}
.action {
width: 300px;
margin-top: 20px;
display: flex;
align-items: center;
justify-content: space-between;
}
.action .dx-selectbox {
width: 90px;
}
.long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
margin-top: 0;
}
[
{ "month": 1, "copper2021": 7970.50, "copper2022": 9775.93, "copper2023": 8999.79, "nickel2021": 17847.68, "nickel2022": 22355.40, "nickel2023": 28194.61, "palladium2021": 2391.20, "palladium2022": 2030.86, "palladium2023": 1734.27 },
{ "month": 2, "copper2021": 8460.25, "copper2022": 9941.35, "copper2023": 8955.20, "nickel2021": 18595.30, "nickel2022": 24015.55, "nickel2023": 26727.95, "palladium2021": 2342.33, "palladium2022": 2350.10, "palladium2023": 1543.90 },
{ "month": 3, "copper2021": 9004.98, "copper2022": 10237.59, "copper2023": 8835.72, "nickel2021": 16460.83, "nickel2022": 33924.18, "nickel2023": 23288.61, "palladium2021": 2525.61, "palladium2022": 2582.78, "palladium2023": 1426.00 },
{ "month": 4, "copper2021": 9335.55, "copper2022": 10183.13, "copper2023": 8814.00, "nickel2021": 16480.91, "nickel2022": 33132.74, "nickel2023": 23894.56, "palladium2021": 2776.45, "palladium2022": 2330.67, "palladium2023": 1508.00 },
{ "month": 5, "copper2021": 10183.97, "copper2022": 9362.81, "copper2023": 8234.28, "nickel2021": 17552.45, "nickel2022": 28062.55, "nickel2023": 21970.39, "palladium2021": 2900.52, "palladium2022": 2060.05, "palladium2023": 1482.61 },
{ "month": 6, "copper2021": 9612.43, "copper2022": 9033.13, "copper2023": 8386.23, "nickel2021": 17942.32, "nickel2022": 25658.63, "nickel2023": 21233.28, "palladium2021": 2752.48, "palladium2022": 1913.05, "palladium2023": 1348.09 },
{ "month": 7, "copper2021": 9433.59, "copper2022": 7529.79, "copper2023": 8445.26, "nickel2021": 18819.36, "nickel2022": 21481.89, "nickel2023": 21091.26, "palladium2021": 2754.76, "palladium2022": 1973.10, "palladium2023": 1264.48 },
{ "month": 8, "copper2021": 9357.19, "copper2022": 7960.98, "copper2023": 8351.77, "nickel2021": 19160.23, "nickel2022": 22057.39, "nickel2023": 20438.65, "palladium2021": 2544.73, "palladium2022": 2135.52, "palladium2023": 1247.30 },
{ "month": 9, "copper2021": 9324.07, "copper2022": 7734.70, "copper2023": 8270.86, "nickel2021": 19398.23, "nickel2022": 22773.97, "nickel2023": 19644.64, "palladium2021": 2130.32, "palladium2022": 2113.95, "palladium2023": 1239.29 },
{ "month": 10, "copper2021": 9778.50, "copper2022": 7621.21, "copper2023": 7939.66, "nickel2021": 19420.52, "nickel2022": 22032.89, "nickel2023": 18281.23, "palladium2021": 2058.48, "palladium2022": 2078.86, "palladium2023": 1142.09 },
{ "month": 11, "copper2021": 9765.48, "copper2022": 8029.95, "copper2023": 8173.95, "nickel2021": 19970.43, "nickel2022": 25562.70, "nickel2023": 17027.36, "palladium2021": 2036.32, "palladium2022": 1911.55, "palladium2023": 1050.27 },
{ "month": 12, "copper2021": 9550.31, "copper2022": 8367.23, "copper2023": 8394.11, "nickel2021": 20015.55, "nickel2022": 28946.81, "nickel2023": 16460.84, "palladium2021": 1810.52, "palladium2022": 1808.36, "palladium2023": 1087.76 }
]

Backend API
<template>
<div>
<div class="long-title"><h3>Monthly Prices of Copper, Nickel and Palladium</h3></div>
<div id="chart-demo">
<table
class="demo-table"
border="1"
>
<tr>
<th><div class="dx-screen-reader-only">Year</div></th>
<th>Copper (USD/ton)</th>
<th>Nickel (USD/ton)</th>
<th>Palladium (USD/troy ounce)</th>
</tr>
<tbody
v-for="(year, index) in years"
:key="index"
>
<RowTemplate
:source="source"
:year="year"
/>
</tbody>
</table>
<div class="action">
<div class="label">Choose a number of months:
</div>
<DxSelectBox
id="choose-months"
:data-source="months"
:input-attr="{ 'aria-label': 'Month' }"
:value="months[0]"
@value-changed="onValueChanged"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import DxSelectBox, { type DxSelectBoxTypes } from 'devextreme-vue/select-box';
import { DataSource, CustomStore } from 'devextreme-vue/common/data';
import RowTemplate from './RowTemplate.vue';
const months = [12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1];
const years = ['2021', '2022', '2023'];
const source = new DataSource({
store: new CustomStore({
load: () => fetch('../../../../data/resourceData.json')
.then((e) => e.json())
.catch(() => { throw new Error('Data Loading Error'); }),
loadMode: 'raw',
}),
filter: ['month', '<=', '12'],
paginate: false,
});
function onValueChanged({ value }: DxSelectBoxTypes.ValueChangedEvent) {
source.filter(['month', '<=', value]);
source.load();
}
</script>
<style>
#chart-demo {
height: 440px;
}
.demo-table {
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
.demo-table th,
.demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #c2c2c2;
}
.demo-table th {
padding: 25px 15px 20px;
border: 1px solid #c2c2c2;
}
.demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
.demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
.demo-table .sparkline {
width: 200px;
height: 30px;
}
.action {
width: 300px;
margin-top: 20px;
display: flex;
align-items: center;
justify-content: space-between;
}
.action .dx-selectbox {
width: 90px;
}
.long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
margin-top: 0;
}
</style>
<template>
<tr class="rows-content">
<th>{{ year }}</th>
<td>
<DxSparkline
:data-source="source"
:show-min-max="true"
:value-field="getValueField('copper')"
class="sparkline"
argument-field="month"
type="bar"
>
<DxTooltip :format="{ type: 'currency', precision: 2 }"/>
</DxSparkline>
</td>
<td>
<DxSparkline
:data-source="source"
:show-min-max="true"
:show-first-last="false"
:value-field="getValueField('nickel')"
class="sparkline"
argument-field="month"
type="bar"
bar-positive-color="#6babac"
min-color="#9ab57e"
max-color="#8076bb"
>
<DxTooltip :format="{ type: 'currency', precision: 2 }"/>
</DxSparkline>
</td>
<td>
<DxSparkline
:data-source="source"
:value-field="getValueField('palladium')"
class="sparkline"
argument-field="month"
type="bar"
bar-positive-color="#e55253"
first-last-color="#ebdd8f"
point-color="#e8c267"
>
<DxTooltip :format="{ type: 'currency', precision: 2 }"/>
</DxSparkline>
</td>
</tr>
</template>
<script setup lang="ts">
import DxSparkline, {
DxTooltip,
} from 'devextreme-vue/sparkline';
const props = withDefaults(defineProps<{
year?: string
source?: object
}>(), {
year: '',
source: () => ({}),
});
const getValueField = (name: string): string => name + props.year;
</script>
<style>
.rows-content td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #c2c2c2;
}
.rows-content tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
.rows-content td:first-of-type {
border-left: 1px solid #c2c2c2;
}
.rows-content .sparkline {
width: 200px;
height: 30px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
[
{ "month": 1, "copper2021": 7970.50, "copper2022": 9775.93, "copper2023": 8999.79, "nickel2021": 17847.68, "nickel2022": 22355.40, "nickel2023": 28194.61, "palladium2021": 2391.20, "palladium2022": 2030.86, "palladium2023": 1734.27 },
{ "month": 2, "copper2021": 8460.25, "copper2022": 9941.35, "copper2023": 8955.20, "nickel2021": 18595.30, "nickel2022": 24015.55, "nickel2023": 26727.95, "palladium2021": 2342.33, "palladium2022": 2350.10, "palladium2023": 1543.90 },
{ "month": 3, "copper2021": 9004.98, "copper2022": 10237.59, "copper2023": 8835.72, "nickel2021": 16460.83, "nickel2022": 33924.18, "nickel2023": 23288.61, "palladium2021": 2525.61, "palladium2022": 2582.78, "palladium2023": 1426.00 },
{ "month": 4, "copper2021": 9335.55, "copper2022": 10183.13, "copper2023": 8814.00, "nickel2021": 16480.91, "nickel2022": 33132.74, "nickel2023": 23894.56, "palladium2021": 2776.45, "palladium2022": 2330.67, "palladium2023": 1508.00 },
{ "month": 5, "copper2021": 10183.97, "copper2022": 9362.81, "copper2023": 8234.28, "nickel2021": 17552.45, "nickel2022": 28062.55, "nickel2023": 21970.39, "palladium2021": 2900.52, "palladium2022": 2060.05, "palladium2023": 1482.61 },
{ "month": 6, "copper2021": 9612.43, "copper2022": 9033.13, "copper2023": 8386.23, "nickel2021": 17942.32, "nickel2022": 25658.63, "nickel2023": 21233.28, "palladium2021": 2752.48, "palladium2022": 1913.05, "palladium2023": 1348.09 },
{ "month": 7, "copper2021": 9433.59, "copper2022": 7529.79, "copper2023": 8445.26, "nickel2021": 18819.36, "nickel2022": 21481.89, "nickel2023": 21091.26, "palladium2021": 2754.76, "palladium2022": 1973.10, "palladium2023": 1264.48 },
{ "month": 8, "copper2021": 9357.19, "copper2022": 7960.98, "copper2023": 8351.77, "nickel2021": 19160.23, "nickel2022": 22057.39, "nickel2023": 20438.65, "palladium2021": 2544.73, "palladium2022": 2135.52, "palladium2023": 1247.30 },
{ "month": 9, "copper2021": 9324.07, "copper2022": 7734.70, "copper2023": 8270.86, "nickel2021": 19398.23, "nickel2022": 22773.97, "nickel2023": 19644.64, "palladium2021": 2130.32, "palladium2022": 2113.95, "palladium2023": 1239.29 },
{ "month": 10, "copper2021": 9778.50, "copper2022": 7621.21, "copper2023": 7939.66, "nickel2021": 19420.52, "nickel2022": 22032.89, "nickel2023": 18281.23, "palladium2021": 2058.48, "palladium2022": 2078.86, "palladium2023": 1142.09 },
{ "month": 11, "copper2021": 9765.48, "copper2022": 8029.95, "copper2023": 8173.95, "nickel2021": 19970.43, "nickel2022": 25562.70, "nickel2023": 17027.36, "palladium2021": 2036.32, "palladium2022": 1911.55, "palladium2023": 1050.27 },
{ "month": 12, "copper2021": 9550.31, "copper2022": 8367.23, "copper2023": 8394.11, "nickel2021": 20015.55, "nickel2022": 28946.81, "nickel2023": 16460.84, "palladium2021": 1810.52, "palladium2022": 1808.36, "palladium2023": 1087.76 }
]

Backend API
<div class="long-title"
><h3>Monthly Prices of Copper, Nickel and Palladium</h3></div
>
<div id="chart-demo">
<table class="demo-table" border="1">
<tr>
<th><div class="dx-screen-reader-only">Year</div></th>
<th>Copper (USD/ton)</th>
<th>Nickel (USD/ton)</th>
<th>Palladium (USD/troy ounce)</th>
</tr>
@for(year of years; track year) {
<tr>
<th>{{ year }}</th>
<td>
<dx-sparkline
class="sparkline"
[dataSource]="source"
argumentField="month"
valueField="copper{{ year }}"
type="bar"
[showMinMax]="true"
>
<dxo-sparkline-tooltip
[format]="{ type: 'currency', precision: 2 }"
></dxo-sparkline-tooltip>
</dx-sparkline>
</td>
<td>
<dx-sparkline
class="sparkline"
[dataSource]="source"
argumentField="month"
valueField="nickel{{ year }}"
type="bar"
[showMinMax]="true"
[showFirstLast]="false"
barPositiveColor="#6babac"
minColor="#9ab57e"
maxColor="#8076bb"
>
<dxo-sparkline-tooltip
[format]="{ type: 'currency', precision: 2 }"
></dxo-sparkline-tooltip>
</dx-sparkline>
</td>
<td>
<dx-sparkline
class="sparkline"
[dataSource]="source"
argumentField="month"
valueField="palladium{{ year }}"
type="bar"
barPositiveColor="#e55253"
firstLastColor="#ebdd8f"
>
<dxo-sparkline-tooltip
[format]="{ type: 'currency', precision: 2 }"
></dxo-sparkline-tooltip>
</dx-sparkline>
</td>
</tr>
}
</table>
<div class="action">
<div class="label">Choose a number of months: </div>
<dx-select-box
id="choose-months"
[dataSource]="filters"
[value]="filters[0]"
(onValueChanged)="onValueChanged($event)"
[inputAttr]="{ 'aria-label': 'Number Of Months' }"
>
</dx-select-box>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { HttpClient, provideHttpClient, withFetch } from '@angular/common/http';
import { lastValueFrom } from 'rxjs';
import { DxSparklineModule, DxSelectBoxModule } from 'devextreme-angular';
import { DataSource, CustomStore } from 'devextreme-angular/common/data';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxSparklineModule,
DxSelectBoxModule,
],
})
export class AppComponent {
source: DataSource;
filters = [12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1];
years: number[];
constructor(http: HttpClient) {
this.source = new DataSource({
store: new CustomStore({
load: () => lastValueFrom(http.get('../../../../data/resourceData.json'))
.catch(() => { throw new Error('Data Loading Error'); }),
loadMode: 'raw',
}),
filter: ['month', '<=', '12'],
paginate: false,
});
this.years = [2021, 2022, 2023];
}
onValueChanged(e) {
const count = e.value;
this.source.filter(['month', '<=', count]);
this.source.load();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
provideHttpClient(withFetch()),
],
});
::ng-deep #chart-demo {
height: 440px;
}
::ng-deep .demo-table {
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
::ng-deep .demo-table th,
::ng-deep .demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #c2c2c2;
}
::ng-deep .demo-table th {
padding: 25px 15px 20px;
border: 1px solid #c2c2c2;
}
::ng-deep .demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
::ng-deep .demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
::ng-deep .demo-table .sparkline {
width: 200px;
height: 30px;
}
::ng-deep .action {
width: 300px;
margin-top: 20px;
display: flex;
align-items: center;
justify-content: space-between;
}
::ng-deep .action .dx-selectbox {
width: 90px;
}
::ng-deep .long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
margin-top: 0;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
[
{ "month": 1, "copper2021": 7970.50, "copper2022": 9775.93, "copper2023": 8999.79, "nickel2021": 17847.68, "nickel2022": 22355.40, "nickel2023": 28194.61, "palladium2021": 2391.20, "palladium2022": 2030.86, "palladium2023": 1734.27 },
{ "month": 2, "copper2021": 8460.25, "copper2022": 9941.35, "copper2023": 8955.20, "nickel2021": 18595.30, "nickel2022": 24015.55, "nickel2023": 26727.95, "palladium2021": 2342.33, "palladium2022": 2350.10, "palladium2023": 1543.90 },
{ "month": 3, "copper2021": 9004.98, "copper2022": 10237.59, "copper2023": 8835.72, "nickel2021": 16460.83, "nickel2022": 33924.18, "nickel2023": 23288.61, "palladium2021": 2525.61, "palladium2022": 2582.78, "palladium2023": 1426.00 },
{ "month": 4, "copper2021": 9335.55, "copper2022": 10183.13, "copper2023": 8814.00, "nickel2021": 16480.91, "nickel2022": 33132.74, "nickel2023": 23894.56, "palladium2021": 2776.45, "palladium2022": 2330.67, "palladium2023": 1508.00 },
{ "month": 5, "copper2021": 10183.97, "copper2022": 9362.81, "copper2023": 8234.28, "nickel2021": 17552.45, "nickel2022": 28062.55, "nickel2023": 21970.39, "palladium2021": 2900.52, "palladium2022": 2060.05, "palladium2023": 1482.61 },
{ "month": 6, "copper2021": 9612.43, "copper2022": 9033.13, "copper2023": 8386.23, "nickel2021": 17942.32, "nickel2022": 25658.63, "nickel2023": 21233.28, "palladium2021": 2752.48, "palladium2022": 1913.05, "palladium2023": 1348.09 },
{ "month": 7, "copper2021": 9433.59, "copper2022": 7529.79, "copper2023": 8445.26, "nickel2021": 18819.36, "nickel2022": 21481.89, "nickel2023": 21091.26, "palladium2021": 2754.76, "palladium2022": 1973.10, "palladium2023": 1264.48 },
{ "month": 8, "copper2021": 9357.19, "copper2022": 7960.98, "copper2023": 8351.77, "nickel2021": 19160.23, "nickel2022": 22057.39, "nickel2023": 20438.65, "palladium2021": 2544.73, "palladium2022": 2135.52, "palladium2023": 1247.30 },
{ "month": 9, "copper2021": 9324.07, "copper2022": 7734.70, "copper2023": 8270.86, "nickel2021": 19398.23, "nickel2022": 22773.97, "nickel2023": 19644.64, "palladium2021": 2130.32, "palladium2022": 2113.95, "palladium2023": 1239.29 },
{ "month": 10, "copper2021": 9778.50, "copper2022": 7621.21, "copper2023": 7939.66, "nickel2021": 19420.52, "nickel2022": 22032.89, "nickel2023": 18281.23, "palladium2021": 2058.48, "palladium2022": 2078.86, "palladium2023": 1142.09 },
{ "month": 11, "copper2021": 9765.48, "copper2022": 8029.95, "copper2023": 8173.95, "nickel2021": 19970.43, "nickel2022": 25562.70, "nickel2023": 17027.36, "palladium2021": 2036.32, "palladium2022": 1911.55, "palladium2023": 1050.27 },
{ "month": 12, "copper2021": 9550.31, "copper2022": 8367.23, "copper2023": 8394.11, "nickel2021": 20015.55, "nickel2022": 28946.81, "nickel2023": 16460.84, "palladium2021": 1810.52, "palladium2022": 1808.36, "palladium2023": 1087.76 }
]

Backend API
import React, { useCallback } from 'react';
import SelectBox, { type SelectBoxTypes } from 'devextreme-react/select-box';
import { DataSource, CustomStore } from 'devextreme-react/common/data';
import RowTemplate from './RowTemplate.tsx';
const months = [12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1];
const years = ['2010', '2011', '2012'];
const monthLabel = { 'aria-label': 'Month' };
const dataSource = new DataSource({
store: new CustomStore({
load: () => fetch('../../../../data/resourceData.json')
.then((e) => e.json())
.catch(() => { throw new Error('Data Loading Error'); }),
loadMode: 'raw',
}),
filter: ['month', '<=', '12'],
paginate: false,
});
function App() {
const onValueChanged = useCallback((e: SelectBoxTypes.ValueChangedEvent) => {
dataSource.filter(['month', '<=', e.value]);
dataSource.load();
}, []);
return (
<React.Fragment>
<div className="long-title"><h3>Monthly Prices of Aluminium, Nickel and Copper</h3></div>
<div id="chart-demo">
<table
className="demo-table"
style={{ border: 1 }}
>
<tbody>
<tr>
<th />
<th>Aluminium (USD/ton)</th>
<th>Nickel (USD/ton)</th>
<th>Copper (USD/ton)</th>
</tr>
{
years.map((year, index) => <RowTemplate
key={index}
year={year}
source={dataSource} />)
}
</tbody>
</table>
<div className="action">
<div className="label">Choose a number of months:</div>
<SelectBox
id="choose-months"
dataSource={months}
inputAttr={monthLabel}
defaultValue={months[0]}
onValueChanged={onValueChanged}
/>
</div>
</div>
</React.Fragment>
);
}
export default App;
import React, { useCallback } from 'react';
import SelectBox from 'devextreme-react/select-box';
import { DataSource, CustomStore } from 'devextreme-react/common/data';
import RowTemplate from './RowTemplate.js';
const months = [12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1];
const years = ['2010', '2011', '2012'];
const monthLabel = { 'aria-label': 'Month' };
const dataSource = new DataSource({
store: new CustomStore({
load: () =>
fetch('../../../../data/resourceData.json')
.then((e) => e.json())
.catch(() => {
throw new Error('Data Loading Error');
}),
loadMode: 'raw',
}),
filter: ['month', '<=', '12'],
paginate: false,
});
function App() {
const onValueChanged = useCallback((e) => {
dataSource.filter(['month', '<=', e.value]);
dataSource.load();
}, []);
return (
<React.Fragment>
<div className="long-title">
<h3>Monthly Prices of Aluminium, Nickel and Copper</h3>
</div>
<div id="chart-demo">
<table
className="demo-table"
style={{ border: 1 }}
>
<tbody>
<tr>
<th />
<th>Aluminium (USD/ton)</th>
<th>Nickel (USD/ton)</th>
<th>Copper (USD/ton)</th>
</tr>
{years.map((year, index) => (
<RowTemplate
key={index}
year={year}
source={dataSource}
/>
))}
</tbody>
</table>
<div className="action">
<div className="label">Choose a number of months:</div>
<SelectBox
id="choose-months"
dataSource={months}
inputAttr={monthLabel}
defaultValue={months[0]}
onValueChanged={onValueChanged}
/>
</div>
</div>
</React.Fragment>
);
}
export default App;
import React from 'react';
import Sparkline, {
Tooltip,
} from 'devextreme-react/sparkline';
import { DataSource } from 'devextreme-react/common/data';
interface RowTemplateProps {
key: number;
year: string;
source: DataSource;
}
export default function RowTemplate(props: RowTemplateProps) {
return (
<tr>
<th>{props.year}</th>
<td>
<Sparkline
dataSource={props.source}
showMinMax={true}
className="sparkline"
argumentField="month"
valueField={`alum${props.year}`}
type="bar"
>
<Tooltip format="currency" />
</Sparkline>
</td>
<td>
<Sparkline
dataSource={props.source}
showMinMax={true}
showFirstLast={false}
className="sparkline"
argumentField="month"
valueField={`nickel${props.year}`}
type="bar"
barPositiveColor="#6babac"
minColor="#9ab57e"
maxColor="#8076bb"
>
<Tooltip format="currency" />
</Sparkline>
</td>
<td>
<Sparkline
dataSource={props.source}
className="sparkline"
argumentField="month"
valueField={`copper${props.year}`}
type="bar"
barPositiveColor="#e55253"
firstLastColor="#ebdd8f"
pointColor="#e8c267"
>
<Tooltip format="currency" />
</Sparkline>
</td>
</tr>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import Sparkline, { Tooltip } from 'devextreme-react/sparkline';
export default function RowTemplate(props) {
return (
<tr>
<th>{props.year}</th>
<td>
<Sparkline
dataSource={props.source}
showMinMax={true}
className="sparkline"
argumentField="month"
valueField={`alum${props.year}`}
type="bar"
>
<Tooltip format="currency" />
</Sparkline>
</td>
<td>
<Sparkline
dataSource={props.source}
showMinMax={true}
showFirstLast={false}
className="sparkline"
argumentField="month"
valueField={`nickel${props.year}`}
type="bar"
barPositiveColor="#6babac"
minColor="#9ab57e"
maxColor="#8076bb"
>
<Tooltip format="currency" />
</Sparkline>
</td>
<td>
<Sparkline
dataSource={props.source}
className="sparkline"
argumentField="month"
valueField={`copper${props.year}`}
type="bar"
barPositiveColor="#e55253"
firstLastColor="#ebdd8f"
pointColor="#e8c267"
>
<Tooltip format="currency" />
</Sparkline>
</td>
</tr>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
[
{ "month": 1, "alum2010": 2262, "alum2011": 2454, "alum2012": 2262, "nickel2010": 18974, "nickel2011": 24298, "nickel2012": 18322, "copper2010": 7341, "copper2011": 9585, "copper2012": 7501 },
{ "month": 2, "alum2010": 2087, "alum2011": 2537, "alum2012": 2087, "nickel2010": 18162, "nickel2011": 27929, "nickel2012": 21093, "copper2010": 7016, "copper2011": 10026, "copper2012": 8470 },
{ "month": 3, "alum2010": 2238, "alum2011": 2586, "alum2012": 2238, "nickel2010": 20535, "nickel2011": 28802, "nickel2012": 19701, "copper2010": 7202, "copper2011": 9889, "copper2012": 8591 },
{ "month": 4, "alum2010": 2349, "alum2011": 2689, "alum2012": 2349, "nickel2010": 24562, "nickel2011": 26142, "nickel2012": 17695, "copper2010": 7851, "copper2011": 9460, "copper2012": 8459 },
{ "month": 5, "alum2010": 2071, "alum2011": 2591, "alum2012": 2071, "nickel2010": 26131, "nickel2011": 26753, "nickel2012": 17549, "copper2010": 7481, "copper2011": 9373, "copper2012": 8320 },
{ "month": 6, "alum2010": 1957, "alum2011": 2584, "alum2012": 1957, "nickel2010": 19278, "nickel2011": 23055, "nickel2012": 16436, "copper2010": 6532, "copper2011": 9108, "copper2012": 7465 },
{ "month": 7, "alum2010": 2008, "alum2011": 2554, "alum2012": 2008, "nickel2010": 19475, "nickel2011": 22870, "nickel2012": 16382, "copper2010": 6498, "copper2011": 9295, "copper2012": 7475 },
{ "month": 8, "alum2010": 2119, "alum2011": 2413, "alum2012": 2119, "nickel2010": 20701, "nickel2011": 24388, "nickel2012": 15687, "copper2010": 7191, "copper2011": 9834, "copper2012": 7430 },
{ "month": 9, "alum2010": 2199, "alum2011": 2327, "alum2012": 2199, "nickel2010": 21266, "nickel2011": 21845, "nickel2012": 16085, "copper2010": 7596, "copper2011": 9121, "copper2012": 7614 },
{ "month": 10, "alum2010": 2374, "alum2011": 2210, "alum2012": 2374, "nickel2010": 23358, "nickel2011": 18346, "nickel2012": 18250, "copper2010": 8057, "copper2011": 7125, "copper2012": 8245 },
{ "month": 11, "alum2010": 2354, "alum2011": 2102, "alum2012": 2354, "nickel2010": 23150, "nickel2011": 18822, "nickel2012": 16083, "copper2010": 8373, "copper2011": 7871, "copper2012": 7727 },
{ "month": 12, "alum2010": 2369, "alum2011": 2038, "alum2012": 2369, "nickel2010": 23282, "nickel2011": 17320, "nickel2012": 17104, "copper2010": 8636, "copper2011": 7725, "copper2012": 7880 }
]
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.7/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart-demo {
height: 440px;
}
.demo-table {
width: 100%;
border: 1px solid #c2c2c2;
border-collapse: collapse;
}
.demo-table th,
.demo-table td {
font-weight: 400;
width: 200px;
padding: 25px 10px 5px;
border: 1px solid #c2c2c2;
}
.demo-table th {
padding: 25px 15px 20px;
border: 1px solid #c2c2c2;
}
.demo-table tr:nth-child(2) td {
border-top: 1px solid #c2c2c2;
}
.demo-table td:first-of-type {
border-left: 1px solid #c2c2c2;
}
.demo-table .sparkline {
width: 200px;
height: 30px;
}
.action {
width: 300px;
margin-top: 20px;
display: flex;
align-items: center;
justify-content: space-between;
}
.action .dx-selectbox {
width: 90px;
}
.long-title h3 {
font-weight: 200;
font-size: 28px;
text-align: center;
margin-bottom: 20px;
margin-top: 0;
}